if( SERVER ) then
	AddCSLuaFile( "shared.lua" )
end

if( CLIENT ) then
	SWEP.PrintName = "Assassins Knife"
	SWEP.Slot = 2
	SWEP.SlotPos = 2
	SWEP.DrawAmmo = false
	SWEP.DrawCrosshair = false
end

SWEP.Author		= "find me"
SWEP.Instructions	= "Left Click - Stab, Right Click - toggle cloaking, Reload - Throw Knife, Shift+movement - Ninja Speed, Hold Space - Ninja Jump."
SWEP.Contact		= "ahr_az@yahoo.com"
SWEP.Purpose		= "KILL"

SWEP.ViewModelFOV	= 62
SWEP.ViewModelFlip	= false
SWEP.IconLetter	= "j"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true

SWEP.NextStrike = 0
  
SWEP.ViewModel      = "models/weapons/v_knife_t.mdl"
SWEP.WorldModel   = "models/weapons/w_knife_t.mdl"
  

SWEP.Primary.Delay			= 0.3 
SWEP.Primary.Recoil			= 0	
SWEP.Primary.Damage			= 15
SWEP.Primary.NumShots		= 1	
SWEP.Primary.Cone			= 0 
SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic   	= false
SWEP.Primary.Ammo         	= "none"
SWEP.Secondary.Delay		= 0.9
SWEP.Secondary.Recoil		= 0
SWEP.Secondary.Damage		= 0
SWEP.Secondary.NumShots		= 1
SWEP.Secondary.Cone			= 0
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic   	= false
SWEP.Secondary.Ammo         = "none"

util.PrecacheSound("weapons/knife/knife_deploy1.wav")
util.PrecacheSound("weapons/knife/knife_hitwall1.wav")
util.PrecacheSound("weapons/knife/knife_hit1.wav")
util.PrecacheSound("weapons/knife/knife_hit2.wav")
util.PrecacheSound("weapons/knife/knife_hit3.wav")
util.PrecacheSound("weapons/knife/knife_hit4.wav")
util.PrecacheSound("weapons/iceaxe/iceaxe_swing1.wav")

if CLIENT then
	killicon.AddFont( "spyknife", "CSKillIcons", SWEP.IconLetter, Color( 255, 245, 40, 255 ) )
end

function SWEP:DrawWeaponSelection(x,y,wide,tall,alpha)
	draw.SimpleText(self.IconLetter,"CSSelectIcons",x+wide/2,y+tall*0.2,Color(255, 245, 10, 255 ),1)
	draw.SimpleText(self.IconLetter,"CSSelectIcons",x+wide/2+math.Rand(-4,4),y+tall*0.2+math.Rand(-14,14),Color(255,210,0,math.Rand(10,120)),1)
	draw.SimpleText(self.IconLetter,"CSSelectIcons",x+wide/2+math.Rand(-4,4),y+tall*0.2+math.Rand(-9,9),Color(255,210,0,math.Rand(10,120)),1)
end

if SERVER then
	function DoSpyRespawn( ply )
		if ply.Cloaked then
			ply.Cloaked = false
			ply:SetColor( 255, 255, 255, 255 )
			ply:DrawViewModel( true )
		end
	end
	hook.Add( "PlayerSpawn", "DoSpyRespawn", DoSpyRespawn )
end

function SWEP:Initialize()
	if( SERVER ) then
		self:SetWeaponHoldType( "melee" )
	end
	self.Hit = { 
	Sound( "weapons/knife/knife_hitwall1.wav" ) }
	self.FleshHit = {
  	Sound( "weapons/knife/knife_hit1.wav" ),
	Sound( "weapons/knife/knife_hit2.wav" ),
	Sound( "weapons/knife/knife_hit3.wav" ),
  	Sound( "weapons/knife/knife_hit4.wav" ) }

end

function SWEP:Precache()
end

function SWEP:Holster()
    self.Owner:SetColor(255,255,255,255)
    self.Owner:SetMaterial("")
    self.Weapon:SetColor(255,255,255,255)
    self.Weapon:SetMaterial("")
    return true
end

function SWEP:Deploy()
    return true
end


function SWEP:PrimaryAttack()
	if( CurTime() < self.NextStrike ) then return end
	self.NextStrike = ( CurTime() + .3 )
	
	local tr = {}
	tr.start = self.Owner:GetShootPos()
	tr.endpos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 75 )
	tr.filter = self.Owner
	tr.mask = MASK_SHOT
	local trace = util.TraceLine( tr )
	
 	if trace.Hit then
		if( trace.Entity:IsPlayer() or trace.Entity:IsNPC() or trace.Entity:GetClass()=="prop_ragdoll" ) then
			self.Owner:EmitSound( self.FleshHit[math.random(1,#self.FleshHit)] )
		else
			self.Owner:EmitSound( self.Hit[math.random(1,#self.Hit)] )
		end
			self.Owner:SetAnimation( PLAYER_ATTACK1 )
			self.Weapon:SendWeaponAnim( ACT_VM_HITCENTER )
				bullet = {}
				bullet.Num    = 1
				bullet.Src    = self.Owner:GetShootPos()
				bullet.Dir    = self.Owner:GetAimVector()
				bullet.Spread = Vector(0, 0, 0)
				bullet.Tracer = 0
				bullet.Force  = 1
				bullet.Damage = 25
			self.Owner:FireBullets(bullet) 
	else
		self.Owner:SetAnimation( PLAYER_ATTACK1 )
		self.Weapon:SendWeaponAnim( ACT_VM_HITCENTER )
		self.Weapon:EmitSound("weapons/iceaxe/iceaxe_swing1.wav")
	end
end

function RemoveKnife( ent )
	if ent:IsValid() then
		ent:Remove()
	end
end


function SWEP:Think()
    if SERVER then
	  	if self.Owner:Health() < 100 then
			self.Owner:SetHealth(self.Owner:Health()+1)
		end
		if self.Owner:IsOnGround() then
		
			if self.Owner:KeyDown(IN_JUMP) or self.Owner:KeyPressed(IN_JUMP) then
				self.Owner:SetVelocity(Vector(0,0,500))
			end

			if self.Owner:KeyDown(IN_SPEED) then
			
            if self.Owner:KeyDown(IN_FORWARD) then
				self.Owner:SetVelocity(self.Owner:GetForward() * 120)
            end

            if self.Owner:KeyDown(IN_BACK) then
				self.Owner:SetVelocity(self.Owner:GetForward() * -120)
            end

            if self.Owner:KeyDown(IN_MOVELEFT) then
				self.Owner:SetVelocity(self.Owner:GetRight() * -120)
            end

            if self.Owner:KeyDown(IN_MOVERIGHT) then
				self.Owner:SetVelocity(self.Owner:GetRight() * 120)
            end
		end
		end
		
			if self.Owner:WaterLevel() > 0 then
				self.Owner:SetVelocity(Vector(0,0,self.Owner:WaterLevel() * 3))
			end
	end
end


 function SWEP:SecondaryAttack()
   if( CurTime() < self.NextStrike ) then return end
    self.NextStrike = ( CurTime() + .5 )
  
    if not self:GetNWBool( "Cloaked", false ) then
        self:SetNWBool( "Cloaked", true )
        self:SetColor( 255, 255, 255, 60 )
       self:SetMaterial( "sprites/heatwave" )
        
        self.Owner:SetColor( 255, 255, 255, 60 )
       self.Owner:SetMaterial( "sprites/heatwave" )
   else
         self:SetNWBool( "Cloaked", false )
        self:SetColor( 255, 255, 255, 255 )
        self:SetMaterial( "" )

    self.Owner:SetColor( 255, 255, 255, 255 )
       self.Owner:SetMaterial( "" )
   end
end


  function SWEP:DrawHUD()
  if self:GetNWBool( "Cloaked", false ) then
     draw.RoundedBox( 0, 140, 540, 85, 45, Color(0, 0, 0, 70))
      draw.SimpleText("Cloaked", "ScoreboardText", 155, 555, Color(225, 200, 0, 255), 0, 0)
   else
       draw.RoundedBox( 0, 140, 540, 85, 45, Color(0, 0, 0, 70))
     draw.SimpleText("Uncloaked", "ScoreboardText", 152, 555, Color(225, 200, 0, 255), 0, 0)
  end
end


function SWEP:Reload()
	if( CurTime() < self.NextStrike ) then return end
	self.NextStrike = ( CurTime() + 1 )
 
    self.Owner:SetAnimation( PLAYER_ATTACK1 )
	self.Weapon:SendWeaponAnim( ACT_VM_HITCENTER )
	self.Weapon:EmitSound("weapons/iceaxe/iceaxe_swing1.wav")
	self.Owner:EmitSound( "weapons/knife/knife_deploy1.wav" )
   
	local tr = self.Owner:GetEyeTrace()
	
	if (!SERVER) then return end
	
	local ent = ents.Create ("thrownknife")

	ent:SetPos (self.Owner:EyePos())
	ent:SetAngles (self.Owner:EyeAngles())
	ent:Spawn()
	
	ent.Thrower = self.Owner

	local phys = ent:GetPhysicsObject()

	local shot_length = tr.HitPos:Length()
	phys:ApplyForceCenter (self.Owner:GetAimVector():GetNormalized() * math.pow (shot_length, 3))

	cleanup.Add (self.Owner, "props", ent)

	undo.Create ("Knife")
	undo.AddEntity (ent)
	undo.SetPlayer (self.Owner)
	undo.Finish()
	
	timer.Simple(20, RemoveKnife, ent) 
end 
