if SERVER then
	AddCSLuaFile("shared.lua")
end

if CLIENT then
	SWEP.PrintName = "Talk"
	SWEP.Slot = 1
	SWEP.SlotPos = 1
	SWEP.DrawAmmo = false
	SWEP.DrawCrosshair = false
end

SWEP.Author = "-[SB]- Spy"
SWEP.Instructions = "Left click to use the selected talking mode. Right click to select a talking mode. Reload to say something without having to be near a player."
SWEP.Contact = ""
SWEP.Purpose = "Create conversations the EASY way."

SWEP.ViewModelFOV = 62
SWEP.ViewModelFlip = false
SWEP.ViewModel = ""
SWEP.WorldModel = ""

SWEP.Spawnable = false
SWEP.AdminSpawnable = true
SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = 0
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = ""

SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = 0
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = ""

function SWEP:Initialize()
	if SERVER then self:SetWeaponHoldType("normal") end
	
	self.Hello = {
	Sound("vo/npc/male01/hi01.wav"),
	Sound("vo/npc/male01/hi02.wav") }
	
	self.GetLost = {
	Sound("vo/npc/male01/vquestion01.wav"),
	Sound("vo/npc/male01/watchwhat.wav"),
	Sound("vo/npc/male01/answer09.wav"),
	Sound("vo/npc/male01/answer30.wav"),
	Sound("vo/npc/male01/busy02.wav") }
	
	self.Sorry = {
	Sound("vo/npc/male01/whoops01.wav"),
	Sound("vo/npc/male01/sorry01.wav"),
	Sound("vo/npc/male01/sorry02.wav"),
	Sound("vo/npc/male01/sorry03.wav"),
	Sound("vo/npc/male01/pardonme01.wav"),
	Sound("vo/npc/male01/pardonme02.wav"),
	Sound("vo/npc/male01/excuseme01.wav"),
	Sound("vo/npc/male01/excuseme02.wav") }
	
	self.Yes = {
	Sound("vo/npc/male01/answer02.wav"),
	Sound("vo/npc/male01/answer03.wav"),
	Sound("vo/npc/male01/answer08.wav"),
	Sound("vo/npc/male01/answer13.wav"),
	Sound("vo/npc/male01/answer15.wav"),
	Sound("vo/npc/male01/answer32.wav") }
	
	self.No = {
	Sound("vo/npc/male01/answer17.wav"),
	Sound("vo/npc/male01/answer10.wav"),
	Sound("vo/npc/male01/answer21.wav"),
	Sound("vo/npc/male01/answer26.wav"),
	Sound("vo/npc/male01/answer27.wav"),
	Sound("vo/npc/male01/answer28.wav"),
	Sound("vo/npc/male01/question14.wav"),
	Sound("vo/npc/male01/vanswer01.wav"),
	Sound("vo/npc/male01/vanswer09.wav") }
	
	self.Thoughts = {
	Sound("vo/npc/male01/answer16.wav"),
	Sound("vo/npc/male01/question02.wav"),
	Sound("vo/npc/male01/question03.wav"),
	Sound("vo/npc/male01/question06.wav"),
	Sound("vo/npc/male01/question09.wav"),
	Sound("vo/npc/male01/question13.wav"),
	Sound("vo/npc/male01/question16.wav"),
	Sound("vo/npc/male01/question19.wav"),
	Sound("vo/npc/male01/question22.wav"),
	Sound("vo/npc/male01/question23.wav"),
	Sound("vo/npc/male01/question27.wav"),
	Sound("vo/npc/male01/question28.wav") }
	
	
	self.DontKnow = {
	Sound("vo/npc/male01/answer22.wav"),
	Sound("vo/npc/male01/answer23.wav"),
	Sound("vo/npc/male01/answer29.wav"),
	Sound("vo/npc/male01/answer35.wav"),
	Sound("vo/npc/male01/answer37.wav") }
	
	self.LookOut = {
	Sound("vo/npc/male01/behindyou01.wav"),
	Sound("vo/npc/male01/behindyou02.wav") }
	
	self.FollowMe = {
	Sound("vo/npc/male01/squad_away02.wav"),
	Sound("vo/npc/male01/squad_away03.wav") }
	
self.SayMode = 1
self.changemode = 0
self.NextSay = 0
end

function SWEP:Think()
end

function SWEP:Deploy()
	if SERVER then
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Greeting mode" )
		self.SayMode = 1
	end
end

function SWEP:Holster(wep)
	self.SayMode = 1
	return true
end

function SWEP:Reload()
	if (CurTime() < self.NextSay) then return end
	
	if self.SayMode == 1 then
		self.Weapon:EmitSound( self.Hello[math.random(1,#self.Hello)] )
	elseif self.SayMode == 2 then
		self.Weapon:EmitSound( self.GetLost[math.random(1,#self.GetLost)] )
	elseif self.SayMode == 3 then
		self.Weapon:EmitSound( self.Sorry[math.random(1,#self.Sorry)] )
	elseif self.SayMode == 4 then
		self.Weapon:EmitSound( self.LookOut[math.random(1,#self.LookOut)] )
	elseif self.SayMode == 5 then
		self.Weapon:EmitSound( "vo/npc/male01/squad_reinforce_single04.wav" )
	elseif self.SayMode == 6 then
		self.Weapon:EmitSound( self.FollowMe[math.random(1,#self.FollowMe)] )
	elseif self.SayMode == 7 then
		self.Weapon:EmitSound( self.Thoughts[math.random(1,#self.Thoughts)] )
	elseif self.SayMode == 8 then
		self.Weapon:EmitSound( self.Yes[math.random(1,#self.Yes)] )
	elseif self.SayMode == 9 then
		self.Weapon:EmitSound( self.No[math.random(1,#self.No)] )
	elseif self.SayMode == 10 then
		self.Weapon:EmitSound( "vo/npc/male01/question26.wav" )
	elseif self.SayMode == 11 then
		self.Weapon:EmitSound( self.DontKnow[math.random(1,#self.DontKnow)] )
	end
	self.NextSay = (CurTime() + 1)
	self:SetNextPrimaryFire(CurTime() + 1)
end


function SWEP:PrimaryAttack()
	local trace = self.Owner:GetEyeTrace()
	if self.SayMode == 1 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.Hello[math.random(1,#self.Hello)] )
	elseif self.SayMode == 2 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.GetLost[math.random(1,#self.GetLost)] )
	elseif self.SayMode == 3 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.Sorry[math.random(1,#self.Sorry)] )
	elseif self.SayMode == 4 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.LookOut[math.random(1,#self.LookOut)] )
	elseif self.SayMode == 5 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( "vo/npc/male01/squad_reinforce_single04.wav" )
	elseif self.SayMode == 6 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.FollowMe[math.random(1,#self.FollowMe)] )
	elseif self.SayMode == 7 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.Thoughts[math.random(1,#self.Thoughts)] )
	elseif self.SayMode == 8 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.Yes[math.random(1,#self.Yes)] )
	elseif self.SayMode == 9 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.No[math.random(1,#self.No)] )
	elseif self.SayMode == 10 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( "vo/npc/male01/question26.wav" )
	elseif self.SayMode == 11 and trace.Entity:IsPlayer() and trace.HitPos:Distance(self.Owner:GetShootPos()) <= 85 then
		self.Weapon:EmitSound( self.DontKnow[math.random(1,#self.DontKnow)] )
	end
	self:SetNextPrimaryFire(CurTime() + 1)
end

function SWEP:SecondaryAttack()
	if self.SayMode == 1 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 2
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Get Lost mode" )

	elseif self.SayMode == 2 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 3
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Sorry mode" )

	elseif self.SayMode == 3 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 4
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Look Out mode" )

	elseif self.SayMode == 4 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 5
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Wait For Me mode" )

	elseif self.SayMode == 5 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 6
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Follow Me mode" )

	elseif self.SayMode == 6 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 7
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Thoughts mode" )
		
	elseif self.SayMode == 7 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 8
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Agree/Yes mode" )

	elseif self.SayMode == 8 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 9
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Disagree/No mode" )
		
	elseif self.SayMode == 9 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 10
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Hell No mode" )
		
	elseif self.SayMode == 10 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 11
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Don't Know mode" )
		
	elseif self.SayMode == 11 and CurTime() > self.changemode then
		self.changemode = CurTime() + 0.1
		self.SayMode = 1
		self.Owner:PrintMessage( HUD_PRINTCENTER, "Greeting mode" )
	end
end 